#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include "hash-gperf.c"

/* letter frequency (scrabble frequencies) */
char scrabble[] = { "AAAAAAAAA"
                    "BB"
                    "CC"
                    "DDDD"
                    "EEEEEEEEEEEE"
                    "FF"
                    "GGG"
                    "HH"
                    "IIIIIIIII"
                    "J"
                    "K"
                    "LLLL"
                    "MM"
                    "NNNNNN"
                    "OOOOOOOO"
                    "PP"
                    "Q"
                    "RRRRRR"
                    "SSSS"
                    "TTTTTT"
                    "UUUU"
                    "VV"
                    "WW"
                    "X"
                    "YY"
                    "Z" };

int main(int argc, char **argv) {
    char table[256];
    int i;
    srandom(0x42CAFE42);
    /* initialize table */
    for (i=0; i<256; i++)
        table[i] = 0;
    /* read contents of gperf hash into table, checking for wraparound
     * conflicts (in case hash value is > 255) */
    for (i=0; i <= (sizeof(wordlist)/sizeof(*wordlist)); i++) {
        if (wordlist[i].name == NULL) continue;
        if (table[i%256] != 0 && table[i%256] != wordlist[i].letter) {
            fprintf(stderr, "Table conflict at %d\n", i);
            return 1; /* failure */
        }
        table[i % 256] = wordlist[i].letter;
    }
    /* now fill in the table with lowercase fillers */
    for (i=0; i<256; i++) {
        char c;
        if (table[i]) continue;
        c = scrabble[random() % (sizeof(scrabble)-1)];
        assert(c);
        table[i] = tolower(c);
    }
    /* output table */
    printf("    DT      \"");
    for (i=0; i<256; i++) {
        printf("%c", table[i]);
    }
    printf("\"\n");
    return 0;
}
